//+------------------------------------------------------------------+
//|                                                         SATL.mq4 |
//|                                                          Valmars |
//|                                         valmars@mail.primorye.ru |
//+------------------------------------------------------------------+
#property copyright "Valmars"
#property link      "valmars@mail.primorye.ru"
#include <stdlib.mqh>
#include <stderror.mqh>
//---- input parameters
extern int TakeProfit = 10;
extern int StopLoss = 75;
extern int slippage=5;
extern int TrailingStop = 9;
extern int MAGIC=12345;
extern int Body=26; // Min    
extern double Lots = 1.0;
extern int mode=0; 
extern double risk=10; 
extern int MaxOrders = 3; 
extern int Period_X = 240;
extern int HourForOpen = 4;
extern bool Info=False;
datetime TimeOpen;
bool Finish=False;
double PrevOpenBuyPrice,PrevOpenSellPrice;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() 
 {
  int      i,ticket,total,type;
  double   vol;
  string symbol = Symbol(); 
if (TrailingStop != 0)
 if (TrailingStop > MarketInfo(symbol,MODE_STOPLEVEL)) TrailingPositions(symbol,TrailingStop,MAGIC);
//----------------------------------------------------------------------------------------------------------------
//    
//----------------------------------------------------------------------------------------------------------------
if (Finish)return;
if (NewBar()) //&& Hour()==HourForOpen)   //  Period_X
 { 
   DeleteStopOrders();

if (AccountFreeMargin( ) < 200) {Finish=true;Print("Finit a la komedia");return;}
if (OrdersTotal()>=MaxOrders)return;
if (mode !=0) 
   vol=MathCeil((AccountFreeMargin()*risk/10000))/10; //    
else 
 	vol=Lots; 
if (vol-MarketInfo(symbol,MODE_MINLOT)<0)vol=MarketInfo(symbol,MODE_MINLOT);
if (vol-MarketInfo(symbol,MODE_MAXLOT)>0)vol=MarketInfo(symbol,MODE_MAXLOT);
if ((iOpen(symbol,Period_X,1) -iClose(symbol,Period_X,1))/Point-Body >0) //   
      {
       double OpenPrice=iClose(symbol,Period_X,1);//iOpen(symbol,Period_X,1);
       if (OpenPrice-Ask-MODE_STOPLEVEL*Point<0) OpenPrice=Ask+MODE_STOPLEVEL*Point;
       if (!StopOrderInstall(vol,OP_BUYSTOP,OpenPrice))
        Print("    BuyStop");
       else
        PrevOpenBuyPrice=OpenPrice;
       
       OpenPrice=iOpen(symbol,Period_X,1); //iLow(symbol,Period_X,1);
       if (OpenPrice-Bid-MODE_STOPLEVEL*Point<0) OpenPrice=Bid+MODE_STOPLEVEL*Point;
       if (!StopOrderInstall(vol,OP_SELLLIMIT,OpenPrice))
        Print("    SellLimit");
       else
        PrevOpenSellPrice=OpenPrice; 
      }
if ((iClose(symbol,Period_X,1) -iOpen(symbol,Period_X,1))/Point-Body >0) //   
     {
      OpenPrice=iOpen(symbol,Period_X,1); //iHigh(symbol,Period_X,1);//
      if (Ask-OpenPrice-MODE_STOPLEVEL*Point<0) OpenPrice=Ask-MODE_STOPLEVEL*Point;
      if (!StopOrderInstall(vol,OP_BUYLIMIT,OpenPrice))
        Print("    BuyLimit");
      else
        PrevOpenBuyPrice=OpenPrice;
      
      OpenPrice=iClose(symbol,Period_X,1);//iOpen(symbol,Period_X,1);
      if (Bid-MODE_STOPLEVEL*Point-OpenPrice<0) OpenPrice=Bid-MODE_STOPLEVEL*Point;
      if (!StopOrderInstall(vol,OP_SELLSTOP,OpenPrice))
        Print("    SellStop");
      else
        PrevOpenSellPrice=OpenPrice; 
     }
/*if (OrdersTotal()==0)
    {
     if (PrevOpenBuyPrice - Ask-MODE_STOPLEVEL*Point<0) PrevOpenBuyPrice=Ask+MODE_STOPLEVEL*Point;
      StopOrderInstall(vol,OP_BUYSTOP,PrevOpenBuyPrice);
     if (Bid-MODE_STOPLEVEL*Point-PrevOpenSellPrice<0) PrevOpenSellPrice=Bid-MODE_STOPLEVEL*Point;
      StopOrderInstall(vol,OP_SELLSTOP,PrevOpenSellPrice);
    }
*/                
 } //  NewBar  
return; 	
} // start() 
//+------------------------------------------------------------------+
bool NewBar()
   {
    bool result=false;
    if (TimeOpen!=iTime(NULL,Period_X,0))   // 
     {result=true;
      TimeOpen=iTime(NULL,Period_X,0);}
    return(result);
   }
//+------------------------------------------------------------------+
//|void TrailingPositions() function                                 |
//+------------------------------------------------------------------+
void TrailingPositions(string symbol,int TrailingStop,int MAGIC) 
{
  int cnt = OrdersTotal();
  for (int i=cnt-1; i>=0; i--) {   
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {int error_code = GetLastError();
  Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
  return ;
      }
    if (OrderSymbol() != symbol || MAGIC != OrderMagicNumber()) continue;        
    if (OrderType() == OP_BUY) 
     {
      if (MarketInfo( symbol, MODE_BID) -OrderOpenPrice()-TrailingStop*MarketInfo(symbol,MODE_POINT) > 0)
       {
        if (NormalizeDouble(MarketInfo( symbol, MODE_BID)-(TrailingStop)*MarketInfo(symbol,MODE_POINT),Digits)
            -NormalizeDouble(OrderStopLoss(),Digits)>0 ) 
         {
          if (!OrderModify(OrderTicket(), OrderOpenPrice(), MarketInfo( symbol, MODE_BID)-TrailingStop*MarketInfo( symbol, MODE_POINT), OrderTakeProfit(), 0, Blue))
           {error_code = GetLastError();
           Print("Error modify order : ", ErrorDescription(error_code), " (", error_code, ")");
           Sleep(10000);RefreshRates( );
           }  
         }
       }
    }

    if (OrderType() == OP_SELL) 
     {
      if (OrderOpenPrice()-MarketInfo( symbol, MODE_ASK)- TrailingStop*MarketInfo( symbol, MODE_POINT) > 0) 
       {
        if (NormalizeDouble(MarketInfo( symbol, MODE_ASK)+(TrailingStop)*MarketInfo( symbol, MODE_POINT),Digits)
            - NormalizeDouble(OrderStopLoss(),Digits) < 0 || OrderStopLoss() == 0) 
         {
           if (!OrderModify(OrderTicket(), OrderOpenPrice(), MarketInfo( symbol, MODE_ASK)+TrailingStop*MarketInfo( symbol, MODE_POINT), OrderTakeProfit(), 0, Red))
            {error_code = GetLastError();
             Print("Error modify order : ", ErrorDescription(error_code), " (", error_code, ")");
             Sleep(10000);RefreshRates( );
            }
         }
       }
     } 
  }
return ;
} 
//+------------------------------------------------------------------+
//|bool StopOrderInstall() function                                  |
//+------------------------------------------------------------------+
bool StopOrderInstall(double vol,int cmd, double OpenPrice)
 {    
     double Sl=0;double Tp=0; bool result=true;
     if (cmd==OP_BUYSTOP || cmd==OP_BUYLIMIT)
     {
      if (StopLoss>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Sl=OpenPrice-StopLoss*Point;
      if (TakeProfit>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Tp=OpenPrice+TakeProfit*Point; 
      if (Info)Print("Ask=",Ask," Buy: OpenPrice=",OpenPrice," StopLoss=",Sl," TakeProfit=",Tp);
     } 
     if (cmd==OP_SELLSTOP|| cmd==OP_SELLLIMIT)
     { 
      if (StopLoss>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Sl=OpenPrice+StopLoss*Point;
      if (TakeProfit>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Tp=OpenPrice-TakeProfit*Point;
      if (Info)Print("Bid=",Bid," Sell: OpenPrice=",OpenPrice," StopLoss=",Sl," TakeProfit=",Tp);
     } 
      int ticket=OrderSend(Symbol(),cmd,vol,OpenPrice,5,Sl,Tp,"",MAGIC, 0 , Yellow); 
      if (ticket<=0)
        {
         result=false;
         int error_code = GetLastError();
         Print("Error opening order : ", ErrorDescription(error_code), " (", error_code, ")");
        }
       Sleep(10000);RefreshRates();
      return(result);
  }
//+------------------------------------------------------------------+
//|bool DeleteStopOrders() function                                  |
//+------------------------------------------------------------------+
bool DeleteStopOrders()
 {  
   int total=OrdersTotal(); 
   for (int i=total-1;i>=0;i--)       
	 { 	
     if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {
       int error_code = GetLastError();
       Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
       return(false);
      }
	  if (OrderSymbol() != Symbol() || MAGIC != OrderMagicNumber())     	
		continue;                        
     if (
         (OrderType()==OP_BUYSTOP && (OrderOpenPrice()-Ask)/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL)) ||
	      (OrderType()==OP_SELLSTOP && (Bid-OrderOpenPrice())/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL))||
	      (OrderType()==OP_BUYLIMIT && (Ask-OrderOpenPrice())/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL))||
	      (OrderType()==OP_SELLLIMIT && (OrderOpenPrice()-Bid)/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL))
	     )
     if (!OrderDelete(OrderTicket()))
	         {
	          error_code = GetLastError();
             Print("Error OrderDelete function: ", ErrorDescription(error_code), " (", error_code, ")");
             Sleep(10000);RefreshRates();
             return(false);
            }
    } //  for
   return(true);
 } 
  